#include <OneWire.h>
#include <DallasTemperature.h>
#include <math.h>
int heater = 7; // D7 Pin to turn on Relay
int time = 0;   // Time counter for cycle timing
int cycle = 1;  // Cycle counter
 
// Data wire is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 2
 
// Setup a oneWire instance to communicate with any OneWire devices 
// (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
 
// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);
 
void setup(void)
{
  Serial.begin(9600);
  sensors.begin();
  pinMode(heater, OUTPUT);  // Set Pin connected to Relay as an OUTPUT
  digitalWrite(heater, LOW);  // Set Pin to LOW to turn Relay OFF
}

void loop(void)
{
  sensors.requestTemperatures(); // Send the command to get temperatures
  Serial.println("Phase 0:Preheat to 95C");
  
  while (sensors.getTempCByIndex(0) < 96.5) {      //***95*** While Loop to Bring up to Temp - 95C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    Serial.print("Temperature is: ");
    Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }
    
//Phase 1: Stay at 95C for 120 sec
  while ( time < 120) {  // ***Set to 121*** While Loop to keep temp at 95C for 120 seconds         
    Serial.print("Phase 1: Stay at 95C for ");
    Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > 95) {                                                                         
         digitalWrite(heater, LOW);
         Serial.println(">95");
         Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
         Serial.println("<95");
         Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   
  
//Phase 2: 95C for 15 sec Cycle  
  time=0;
  while ( time <16) {   // Hold at 95C for 15 sec.
    Serial.print("Phase 2: Hold at 95 for ");
    Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > 95) {                                                                         
         digitalWrite(heater, LOW);
         Serial.println(">95");
         Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
         Serial.println("<95");
         Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   
 
//Phase 3: Drop Temp to 55C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  Serial.println("Phase 3:Drop to 55C");

  while (sensors.getTempCByIndex(0) > 56) {      //***55*** While Loop to Drop Temp - 55C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    Serial.print("Temperature is: ");
    Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, LOW);
    delay(1000);
  }

//Phase 4: 55C for 15 sec Cycle  

  time=0;
  while ( time <16) {   // Hold at 55C for 15 sec.
    Serial.print("Phase 4: Hold at 55 for ");
    Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > 55) {                                                                         
         digitalWrite(heater, LOW);
         Serial.println(">55");
         Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
         Serial.println("<55");
         Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   


//Phase 5: Increase Temp to 68C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  Serial.println("Phase 5:Increase to 68C");

  while (sensors.getTempCByIndex(0) < 68) {      //***68*** While Loop to Bring up to Temp - 68C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    Serial.print("Temperature is: ");
    Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }

//Phase 6: 68C for 15 sec Cycle  

  time=0;
  while ( time <46) {   // Hold at 68C for 45 sec.
    Serial.print("Phase 6: Hold at 68 for ");
    Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > 68) {                                                                         
         digitalWrite(heater, LOW);
         Serial.println(">67");
         Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
         Serial.println("<68");
         Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   

//Phase 7: Increase Temp to 95C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  Serial.println("Phase 7:Increase to 95C");

  while (sensors.getTempCByIndex(0) < 95) {      //***95*** While Loop to Bring up to Temp - 95C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    Serial.print("Temperature is: ");
    Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }

    
digitalWrite(heater, LOW);  // Set Pin to LOW to turn Relay OFF
Serial.println("this is the end");
Serial.println();
while(true);


}
